//
// C++ Interface: eventslistproperty
//
// Description: 
//
//
// Author: Gaël de Chalendar <ksirk@tuxfamily.org>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KSIRK_GAMELOGICEVENTSLISTPROPERTY_H
#define KSIRK_GAMELOGICEVENTSLISTPROPERTY_H

#include "kgame/kgamepropertylist.h"
#include<qvaluelist.h>
#include<qstring.h>
#include<qpoint.h>
#include<qpair.h>

namespace Ksirk {

namespace GameLogic {

/**
@author Gaël de Chalendar
*/
// class EventsListProperty : public KGamePropertyList< QPair< QString, QPoint > >
class EventsListProperty : public QValueList< QPair< QString, QPoint > >
{
public:
  EventsListProperty();

  virtual ~EventsListProperty();

  /**
    * This will read the value of this property from the stream. You MUST
    * overwrite this method in order to use this class
    * @param s The stream to read from
    **/
//   virtual void load(QDataStream& s);
  
  /**
    * Write the value into a stream. MUST be overwritten
    **/
//   virtual void save(QDataStream& s);
  
  /**
    * send a command to advanced properties like arrays
    * @param stream The stream containing the data of the comand
    * @param msgid The ID of the command - see PropertyCommandIds
    * @param isSender whether this client is also the sender of the command
    **/
//   virtual void command(QDataStream &stream, int msgid, bool isSender=false);
  
  void pop_front();
  
  void push_back(const QPair<QString, QPoint>& pair);

private:
//   QByteArray buffer;
  
};

}

}

#endif
