//
// C++ Interface: armysprite
//
// Description: 
//
//
// Author: Gaël de Chalendar <kleag@free.fr>, (C) 2003
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KSIRKARMYSPRITE_H
#define KSIRKARMYSPRITE_H

#include "animsprite.h"

namespace Ksirk {

/**
An ArmySprite is a sprite that represents a certain number of armies

@author Gaël de Chalendar
*/
class ArmySprite : public AnimSprite
{
public:
    ArmySprite(QCanvasPixmapArray* pma, const QString &imgPath,
            BackGnd* aBackGnd, unsigned int nbFrames, unsigned int nbDirs, unsigned int visibility = 200) :
        AnimSprite(pma, imgPath, aBackGnd, nbFrames, nbDirs, visibility)
    {
    }

    virtual ~ArmySprite() {};

    inline virtual size_t nbArmies() const = 0 ;
};

};

#endif
