//
// C++ Interface: CannonSprite
//
// Description: 
//
//
// Author: Gaël de Chalendar <kleag@free.fr>, (C) 2003
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KSIRKCAVALRYSPRITE_H
#define KSIRKCAVALRYSPRITE_H

#include "armysprite.h"

namespace Ksirk {

/**
A CavalrySpritei is an army sprite that represents 5 armies

@author Gaël de Chalendar
*/
class CavalrySprite : public ArmySprite
{
public:
    CavalrySprite(QCanvasPixmapArray* pma, const QString &imgPath, BackGnd* aBackGnd,
            unsigned int nbFrames, unsigned int nbDirs, unsigned int visibility = 200);

    virtual ~CavalrySprite() {}

    inline virtual size_t nbArmies() const {return m_nbArmies;}

private:
    static const size_t m_nbArmies = 5;
};

};

#endif
