//
// C++ Interface: CannonSprite
//
// Description: 
//
//
// Author: Gaël de Chalendar <kleag@free.fr>, (C) 2003
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KSIRKINFANTRYSPRITE_H
#define KSIRKINFANTRYSPRITE_H

#include "armysprite.h"

namespace Ksirk {

/**
A InfantrySprite is an army sprite that represents 1 army

@author Gaël de Chalendar
*/
class InfantrySprite : public ArmySprite
{
public:
    InfantrySprite(QCanvasPixmapArray* pma, const QString &imgPath, BackGnd* aBackGnd,
            unsigned int nbFrames, unsigned int nbDirs, unsigned int visibility = 200);

    virtual ~InfantrySprite() {}

    inline virtual size_t nbArmies() const {return m_nbArmies;}

private:
    static const size_t m_nbArmies = 1;
};

};

#endif
